package com.blamejared.compat.botania.handlers;

import java.util.Iterator;
import crafttweaker.CraftTweakerAPI;
import java.util.Collection;
import com.blamejared.mtlib.helpers.StackHelper;
import java.util.LinkedList;
import com.blamejared.mtlib.utils.BaseListRemoval;
import com.blamejared.mtlib.helpers.LogHelper;
import java.util.List;
import java.util.Collections;
import vazkii.botania.api.BotaniaAPI;
import com.blamejared.mtlib.utils.BaseListAddition;
import crafttweaker.mc1120.item.MCItemStack;
import java.util.ArrayList;
import net.minecraft.item.ItemStack;
import stanhebben.zenscript.annotations.ZenMethod;
import vazkii.botania.api.recipe.RecipeElvenTrade;
import com.blamejared.mtlib.helpers.InputHelper;
import com.blamejared.ModTweaker;
import crafttweaker.api.item.IIngredient;
import crafttweaker.api.item.IItemStack;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.annotations.ModOnly;
import stanhebben.zenscript.annotations.ZenClass;

@ZenClass("mods.botania.ElvenTrade")
@ModOnly("botania")
@ZenRegister
public class ElvenTrade
{
    protected static final String name = "Botania Eleven Trade";
    
    @ZenMethod
    public static void addRecipe(final IItemStack[] outputs, final IIngredient[] input) {
        ModTweaker.LATE_ADDITIONS.add(new Add(new RecipeElvenTrade(InputHelper.toStacks(outputs), InputHelper.toObjects(input))));
    }
    
    @ZenMethod
    public static void removeRecipe(final IIngredient output) {
        ModTweaker.LATE_REMOVALS.add(new Remove(output));
    }
    
    public static IItemStack[] toStacks(final ItemStack[] iIngredient) {
        final ArrayList<IItemStack> stacks = new ArrayList<IItemStack>();
        for (final ItemStack stack : iIngredient) {
            stacks.add((IItemStack)new MCItemStack(stack));
        }
        return stacks.toArray(new IItemStack[stacks.size()]);
    }
    
    private static class Add extends BaseListAddition<RecipeElvenTrade>
    {
        public Add(final RecipeElvenTrade recipe) {
            super("Botania Eleven Trade", BotaniaAPI.elvenTradeRecipes, (List)Collections.singletonList(recipe));
        }
        
        public String getRecipeInfo(final RecipeElvenTrade recipe) {
            return LogHelper.getStackDescription((Object)recipe.getOutputs());
        }
    }
    
    private static class Remove extends BaseListRemoval<RecipeElvenTrade>
    {
        final IIngredient output;
        
        public Remove(final IIngredient output) {
            super("Botania Eleven Trade", BotaniaAPI.elvenTradeRecipes);
            this.output = output;
        }
        
        public String getRecipeInfo(final RecipeElvenTrade recipe) {
            return LogHelper.getStackDescription((Object)recipe.getOutputs());
        }
        
        public void apply() {
            final LinkedList<RecipeElvenTrade> recipes = new LinkedList<RecipeElvenTrade>();
            for (final RecipeElvenTrade entry : BotaniaAPI.elvenTradeRecipes) {
                if (entry != null && entry.getOutputs() != null && StackHelper.matches(this.output, ElvenTrade.toStacks(entry.getOutputs().toArray(new ItemStack[entry.getOutputs().size()])))) {
                    recipes.add(entry);
                }
            }
            if (!recipes.isEmpty()) {
                this.recipes.addAll(recipes);
                super.apply();
            }
            else {
                LogHelper.logWarning(String.format("No %s Recipe found for %s. Command ignored!", "Botania Eleven Trade", this.output.toString()));
            }
            CraftTweakerAPI.getLogger().logInfo(super.describe());
        }
        
        public String describe() {
            return "Attempting to remove Elven Trade recipe for " + this.output.getItems();
        }
    }
}
